aboutsummaryrefslogtreecommitdiff
path: root/graphics/klayout
diff options
context:
space:
mode:
authorLockywolf <for_sbo.klayout_2023-07-3@lockywolf.net>2023-07-08 12:45:03 +0900
committerWilly Sudiarto Raharjo <willysr@slackbuilds.org>2023-07-08 16:41:52 +0700
commita607515b3c810c969e7661d7785e0b3091ee479b (patch)
tree9b992ed5a458707661a64e9df3b4fd961e165505 /graphics/klayout
parent893a03e6cbf6bf8ad04bdd1797ca6954b4bb5b05 (diff)
downloadslackbuilds-a607515b3c810c969e7661d7785e0b3091ee479b.tar.xz
graphics/klayout: Added (gds/oas file tool).
Signed-off-by: Andrew Clemons <andrew.clemons@gmail.com> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'graphics/klayout')
-rw-r--r--graphics/klayout/README22
-rw-r--r--graphics/klayout/doinst.sh7
-rw-r--r--graphics/klayout/klayout.SlackBuild171
-rw-r--r--graphics/klayout/klayout.desktop7
-rw-r--r--graphics/klayout/klayout.info10
-rw-r--r--graphics/klayout/slack-desc19
6 files changed, 236 insertions, 0 deletions
diff --git a/graphics/klayout/README b/graphics/klayout/README
new file mode 100644
index 000000000000..7c51c499efc8
--- /dev/null
+++ b/graphics/klayout/README
@@ -0,0 +1,22 @@
+KLayout is a popular and open-source layout viewer and editor for GDS
+and OASIS formats. It's used primarily in the field of Electronic
+Design Automation (EDA).
+
+GDS and OASIS are file formats for design layouts of integrated
+circuits. KLayout allows users to view these complex layouts in a
+human-readable form, zooming in and out, panning, and moving around
+the design.
+
+In addition to viewing capabilities, KLayout also provides editing
+features. Users can manipulate the layout, changing shapes and
+patterns, or creating new elements from scratch.
+
+The software provides many more features useful in EDA, including:
+
+Support for different file formats like GDSII, OASIS, DXF, CIF, etc.
+Powerful search capabilities to locate specific elements in complex
+designs. A macro development environment that lets users automate
+tasks. Layout vs. Schematic (LVS) comparison tools. Overall, KLayout
+is a highly useful tool for anyone working in electronics design or
+fabrication, as it allows the inspection and modification of intricate
+IC designs.
diff --git a/graphics/klayout/doinst.sh b/graphics/klayout/doinst.sh
new file mode 100644
index 000000000000..318705f972ed
--- /dev/null
+++ b/graphics/klayout/doinst.sh
@@ -0,0 +1,7 @@
+if [ -x /usr/bin/update-mime-database ]; then
+ /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
+fi
+
+if [ -x /usr/bin/update-desktop-database ]; then
+ /usr/bin/update-desktop-database -q usr/share/applications >/dev/null 2>&1
+fi
diff --git a/graphics/klayout/klayout.SlackBuild b/graphics/klayout/klayout.SlackBuild
new file mode 100644
index 000000000000..e92f62b20e61
--- /dev/null
+++ b/graphics/klayout/klayout.SlackBuild
@@ -0,0 +1,171 @@
+#!/bin/bash
+
+# Slackware build script for klayout
+
+# Copyright 2023, Lockywolf
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=klayout
+VERSION=${VERSION:-0.28.9}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.*z?
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir builddir
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+QMAKE_CCACHE=1 \
+./build.sh \
+ -bin builddir/bin \
+ -build builddir/build \
+ -j4 \
+ -libcurl \
+ -libexpat \
+ -libpng
+#( cd $PKG
+ find builddir | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || :
+ find builddir | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || :
+#)
+
+install -D -m 644 $CWD/klayout.desktop "$PKG"/usr/share/applications/klayoutEditor.desktop
+
+PYTHON_VERSION=$(python3 -c 'import sys; print("{}.{}".format(sys.version_info.major, sys.version_info.minor))')
+mkdir -p $PKG/usr/lib$LIBDIRSUFFIX/python"${PYTHON_VERSION}"/site-packages/klayout
+cp -pdr builddir/bin/pymod/* $PKG/usr/lib$LIBDIRSUFFIX/python"${PYTHON_VERSION}"/site-packages/
+for d in tl db rdb; do
+ mkdir -p $PKG/usr/lib$LIBDIRSUFFIX/python"${PYTHON_VERSION}"/site-packages/klayout/$d
+ cp -pd builddir/bin/pymod/klayout/$d/* $PKG/usr/lib$LIBDIRSUFFIX/python"${PYTHON_VERSION}"/site-packages/klayout/$d/
+# chmod 644 $PKG/usr/lib$LIBDIRSUFFIX/python"${PYTHON_VERSION}"/site-packages/klayout/$d/*
+done
+find -L $PKG/usr/lib$LIBDIRSUFFIX/python"${PYTHON_VERSION}"/site-packages/klayout \
+ -type d -exec chmod 755 {} \; -o -type f -exec chmod 644 {} \;
+
+# lib
+
+mkdir -p $PKG/usr/lib$LIBDIRSUFFIX/klayout
+cp -pd builddir/bin/*.so* $PKG/usr/lib$LIBDIRSUFFIX/klayout/
+chmod 644 $PKG/usr/lib$LIBDIRSUFFIX/klayout/*.so*
+
+mkdir -p $PKG/usr/lib$LIBDIRSUFFIX/klayout/db_plugins
+cp -pd builddir/bin/db_plugins/*.so* $PKG/usr/lib$LIBDIRSUFFIX/klayout/db_plugins/
+chmod 644 $PKG/usr/lib$LIBDIRSUFFIX/klayout/db_plugins/*.so*
+
+mkdir -p $PKG/usr/lib$LIBDIRSUFFIX/klayout/lay_plugins
+cp -pd builddir/bin/lay_plugins/*.so* $PKG/usr/lib$LIBDIRSUFFIX/klayout/lay_plugins/
+chmod 644 $PKG/usr/lib$LIBDIRSUFFIX/klayout/lay_plugins/*.so*
+
+# pymod
+# cd /tmp/klayout/%{_libdir}/klayout/pymod
+# #install pymod
+# for f in `find`; do
+# if [ -f "$f" ]; then
+# install -Dm644 "$f" "%{buildroot}%{python3_sitearch}/$f"
+# fi
+# done
+
+# create and populate bindir
+mkdir -p $PKG/usr/bin
+cp -pd builddir/bin/klayout builddir/bin/strm* $PKG/usr/bin/
+chmod 755 $PKG/usr/bin
+
+# create and populate includes
+mkdir -p $PKG/usr/include/klayout
+mkdir -p $PKG/usr/include/klayout/atomic
+find . -name '*.h' -exec install -Dm644 {} $PKG/usr/include/klayout \;
+install -Dm644 $PKG/usr/include/klayout/atomic.h $PKG/usr/include/klayout/atomic/
+install -Dm644 $PKG/usr/include/klayout/atomic_msvc.h $PKG/usr/include/klayout/atomic/
+install -Dm644 $PKG/usr/include/klayout/spinlock.h $PKG/usr/include/klayout/atomic/
+
+#other
+install -Dm644 etc/klayout.desktop $PKG/usr/share/applications/klayout.desktop
+install -Dm644 etc/logo.png $PKG/usr/share/pixmaps/klayout.png
+
+# ldconfing idiocy
+for mfile in $(find $PKG/ -type f -exec file {} + | grep ELF | awk -F: '{print $1}') ; do
+ old_rpath=$(patchelf --print-rpath $mfile)
+ patchelf --set-rpath ${old_rpath}:/usr/lib$LIBDIRSUFFIX/klayout/ $mfile
+done
+
+
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ README.md CONTRIB COPYRIGHT \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/graphics/klayout/klayout.desktop b/graphics/klayout/klayout.desktop
new file mode 100644
index 000000000000..7ceedc7dabb0
--- /dev/null
+++ b/graphics/klayout/klayout.desktop
@@ -0,0 +1,7 @@
+[Desktop Entry]
+Type=Application
+Name=klayout
+GenericName=GDS2 chip layout Viewer
+Categories=Education;Math;
+Exec=klayout
+Icon=klayout
diff --git a/graphics/klayout/klayout.info b/graphics/klayout/klayout.info
new file mode 100644
index 000000000000..a3a685f97f3a
--- /dev/null
+++ b/graphics/klayout/klayout.info
@@ -0,0 +1,10 @@
+PRGNAM="klayout"
+VERSION="0.28.9"
+HOMEPAGE="https://www.klayout.de"
+DOWNLOAD="https://www.klayout.org/downloads/source/klayout-0.28.9.tar.bz2"
+MD5SUM="bb49d7042f71d48c08cbc9959b72abf6"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Lockywolf"
+EMAIL="for_sbo.klayout_2023-07-3@lockywolf.net"
diff --git a/graphics/klayout/slack-desc b/graphics/klayout/slack-desc
new file mode 100644
index 000000000000..d334724cc938
--- /dev/null
+++ b/graphics/klayout/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+klayout: klayout (Tool to view and edit gds/oas files.)
+klayout:
+klayout: KLayout is a popular and open-source layout viewer and editor for GDS
+klayout: and OASIS formats. It's used primarily in the field of Electronic
+klayout: Design Automation (EDA).
+klayout:
+klayout:
+klayout:
+klayout:
+klayout:
+klayout: